#!/usr/bin/env python
# coding: utf-8

from intelliw.datasets.datasets import DataSets
from .pipeline import Pipeline
from intelliw.utils.logger import get_logger

logger = get_logger()


class Trainer:
    def __init__(self, path, response_addr=None, perodic_interval=-1):
        self.pipeline = Pipeline(response_addr, perodic_interval)
        self.pipeline.importmodel(path, False)

    def train(self, train_data, val_data):
        return self.pipeline.train(train_data, val_data)

    def new_train(self, datasets: DataSets):
        if not isinstance(datasets, DataSets):
            raise TypeError("datasets has a wrong type, required: DataSets, actually: {}"
                            .format(type(datasets).__name__))

        return self.pipeline.new_train(datasets)

    def perodic_callback(self):
        self.pipeline.perodic_callback_train()
